<?PHP
class Image {

    var $name;
    var $exif;
    var $time = 0;

    function Image ($filename) {
        $this->name = $filename;
        $this->time = filemtime($filename);

	if (!function_exists('exif_read_data')) return;

        $this->$exif = exif_read_data ($filename);
        $datetime = $this->$exif['DateTime'];
        if ($datetime <> '') {
            $yyyy = substr($datetime, 0, 4);
            $mmm  = substr($datetime, 5, 2);
            $dd   = substr($datetime, 8, 2);
            $hh   = substr($datetime, 11, 2);
            $mm   = substr($datetime, 14, 2);
            $ss   = substr($datetime, 17, 2);
            $this->time = time ($hh, $mm, $ss, $mmm, $dd, $yyyy);
        }
    }

    function GetExif() {
	$exif = exif_read_data($this->filename, 0, true);
	$result = '';
        foreach ($exif as $key => $section) {
            foreach ($section as $name => $val) {
                $result .= "$key.$name: $val<br />\n";
	    }
	}
	return $result;
    }

    // Return comment string from rdjpgcom
    //
    function GetComment () {
        if (file_exists($this->name)) {
            exec("rdjpgcom ".escapeshellarg($this->name), $commentlines);
            return implode("", $commentlines);
        } else return "";
    }

    // Remove CR/LF and HTML tags from comment string
    //
    function GetCleanComment () {
        return htmlentities(strip_tags(strtr($this->GetComment(), "\r\n", "  ")));
    }

    // Set comment string via wrjpgcom
    //
    function SetComment ($comment) {
        $tmp = $this->name.".tmp";
        $c = $comment == "" ? "''" : escapshellarg($comment);
        $f = escapeshellarg($this->name);
        $t = escapeshellarg($tmp);
        exec("wrjpgcom -replace -comment $c $f > $t");
        //touch ($tmp, filemtime($this->name));
        if (file_exists($tmp) and filesize($tmp) > 0) {
            return rename($tmp, $this->name);
        }
    }

    // Create cached version of resized image
    //
    function CreateCache ($cache, $newsize) {
        if (!file_exists($cache)) {
            $c = escapeshellarg($cache);
            $f = escapeshellarg($this->name);
            $x = $newsize . 'x' . $newsize;
            exec("convert -size $x -resize $x $f $c");
        }
    }

    // Return HTML thumbnail reference
    //
    function GetThumbnail ($path, $href, $size=140) {
        $comment = $this->GetCleanComment();
        $title = date("j-M-y H:i:s ", $this->time) . $comment;

	$name  = rawurlencode(basename($this->name));
        $thumb = "/cache/$size" . "$path/$name";

        return "<a title=\"$title\" href=\"$href\">" .
               "<img src=\"$thumb\" alt=\"$comment\" /></a>";
    }

} // Image
?>
